/*
 * Chuckmin 
 *
 * 2013 http://cubic9.com 
 *
 * original sketch is WiiChuckDemo
 *   by 2008 Tod E. Kurt, http://thingm.com/
 *
 */

#include <Wire.h>
#include "nunchuck_funcs.h"

#define NOTE_A5  880
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_D6  1175
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_G6  1568
#define NOTE_A6  1760
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_D7  2349
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_G7  3136
#define NOTE_A7  3520
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_D8  4699
#define NOTE_E8  5274
#define NOTE_F8  5588
#define NOTE_G8  6272

#define BUZZER 10
#define DEBUG 0
#define INTERVAL 50
#define LENGTH 100

int loop_cnt = 0;

byte accx,accy,accz,zbut,cbut,joyx,joyy;
int ledPin = 13;
int base;
int shift;

// ヨナ抜き音階
/*
int notes[] = {
  NOTE_A5, NOTE_C6, NOTE_D6, NOTE_E6, NOTE_G6, 
  NOTE_A6, NOTE_C7, NOTE_D7, NOTE_E7, NOTE_G7, 
  NOTE_A7, NOTE_C8, NOTE_D8, NOTE_E8, NOTE_G8
};
*/

// ニロ抜き音階
int notes[] = {
  NOTE_B5, NOTE_C6, NOTE_E6, NOTE_F6, NOTE_G6, 
  NOTE_B6, NOTE_C7, NOTE_E7, NOTE_F7, NOTE_G7,
  NOTE_B7, NOTE_C8, NOTE_E8, NOTE_F8, NOTE_G8
};

void setup()
{
    #if DEBUG
        Serial.begin(19200);
    #endif
    nunchuck_setpowerpins();
    nunchuck_init(); // send the initilization handshake
    
    #if DEBUG
        Serial.print("WiiChuckDemo ready\n");
    #endif
}

void loop()
{
    if( loop_cnt > INTERVAL ) {
        loop_cnt = 0;

        nunchuck_get_data();

        accx  = nunchuck_accelx(); // ranges from approx 70 - 182
        accy  = nunchuck_accely(); // ranges from approx 65 - 173
        accz  = nunchuck_accelz();
        zbut  = nunchuck_zbutton();
        cbut  = nunchuck_cbutton(); 
        joyx  = nunchuck_joyx();
        joyy  = nunchuck_joyy();
            
        #if DEBUG
            Serial.print(" accx:"); Serial.print((byte)accx,DEC);
            Serial.print(" accy:"); Serial.print((byte)accy,DEC);
            Serial.print(" accz:"); Serial.print((byte)accz,DEC);
            Serial.print(" zbut:"); Serial.print((byte)zbut,DEC);
            Serial.print(" cbut:"); Serial.print((byte)cbut,DEC);
            Serial.print(" joyx:"); Serial.print((byte)joyx,DEC);
            Serial.print(" joyy:"); Serial.println((byte)joyy,DEC);
        #endif

        base = notes[(accx - 70) / 9];
        shift = (joyy - 129) * 8; 
        tone(BUZZER, (base + shift) * cbut, LENGTH);
    }
    loop_cnt++;
    delay(1);
}


